Attribute VB_Name = "Solver_Fnct"
Option Explicit
Option Base 1
'Solver Constants
'====================================
'integration methods: 0=midpoint, 1=trapezoidal
Global Const i_midpoint      = 0
Global Const i_trapezoidal   = 1

'; 'Finds the greatest common factor of two longs
Public Declare Function GCF Lib "aNuMet.dll" ( _
       ByVal int1 As Long,  _
       ByVal int2 As Long) As Long

'; 'Finds the Lowest Common Multiple of two long
Public Declare Function LCM Lib "aNuMet.dll" ( _
       ByVal int1 As Long,  _
       ByVal int2 As Long) As Long

';integrate expression between x0 to xN, with N1 intervals, result as double
Public Declare Function dIntegrate Lib "aNuMet.dll" ( _
       ByVal expr As String,  _
       ByVal x0 As Double,  _
       ByVal xN As Double,  _
       ByVal N1 As Long,  _
       ByVal method As Long,  _
       ByVal sVar As String) As Double
' use one  of these three methods: 0=midpoint, 1=trapezoidal, 2=Simpson's (requires N1 to be odd)
' sVaris is a string containing the variable name in expr (es. "123*2+x-x^2" => sVar="x")

'; 'Calculates the solution of a Polynomial with Newton Method
Public Declare Function dPolySolve Lib "aNuMet.dll" ( _
       ByVal sPolyn As String,  _
       ByVal sVar As String) As Double
' polynomial automatically set equal to 0; sVar is variable in the polynomial (in "x^2-2" it would be "x")

'; 'Uses Newton's method to solve (numerically) a polynomial equation set equal to zero
Public Declare Function dSolve Lib "aNuMet.dll" ( _
       ByVal Polyn As String,  _
       ByVal sVar As String) As Double
' i.e. polynomial should be "3*x^2-1" instead of "3*x^2-2=0"

';integrate expression between x0 to xN, with N1 intervals, result pointed by *dRetVal
Public Declare Function Integrate Lib "aNuMet.dll" ( _
       ByVal expr As String,  _
       ByVal x0 As Double,  _
       ByVal xN As Double,  _
       ByVal N1 As Long,  _
       ByVal method As Long,  _
       ByVal sVar As String,  _
       dRetVal As Double) As Long
' use one  of these two methods: 0=midpoint, 1=trapezoidal
' sVaris is a string containing the variable name in expr (es. "123*2+x-x^2" => sVar="x")

';'Gets the derivative of a polynomial with a specific variable;
Public Declare Function lPoly_dydx Lib "aNuMet.dll" ( _
       ByVal Expr As String,  _
       ByVal sVar As String) As Long
'sVar is the variable in Expr (es: Expr=3 + 2x^2 - 3x^4: sVar=x)
'returns pointer to string with result

';'Gets the derivative of a polynomial with a specific variable;
Public Declare Function Poly_dydx Lib "aNuMet.dll" ( _
       ByVal Expr As String,  _
       ByVal sVar As String) As String
'sVar is the variable in Expr (es: Expr=3 + 2x^2 - 3x^4: sVar=x)
'returns pointer to string with result

'; 'Calculate a guess for Newton's Method
Public Declare Function sPolyNewt Lib "aNuMet.dll" ( _
       ByVal sPolyn As String,  _
       ByVal sVar As String,  _
       ByVal loops As Long) As String
' parameters: sPolyn = Polynomial, sVar=variable of the Polynomial, Loops=Number of Loops of approximation
' polynomial must set to 0; sVar is the variable in the polynomial (in "3*x^2-1" it is "x")

'; 'Uses Newton method to solve (numerically) a polynomial equation set equal to zero
Public Declare Function sSolve Lib "aNuMet.dll" ( _
       ByVal sPolyn As String,  _
       ByVal sVar As String,  _
       ByVal Loops As Long) As String
' i.e. polynomial should be "x^2-2" instead of "x^2-2=0"

