Attribute VB_Name = "aNuMet_Fnct"
Option Explicit
Option Base 1
'Constants definition
'====================
Global Const Zero = 0.000000000001 '1.00E-15
Global Const pi2 = 1.5707963267949
Global Const tpi = 6.28318530717958
Global Const degs = 57.2957795130823
Global Const rads = 1.74532925199433E-02
'aMatrix Returned values (ExitCodes)
'====================================
Global Const aInvalidParam= -22 'Invalid Parameter. Unable to return string
Global Const aMatrSingAng=  -21  'Singolarity
Global Const aMatrOK=       -1  'No Error
Global Const aMatrError=    0   'Undefined error (procedure exit before completion)
Global Const aMatrOrdDiff=  1   'Orders not equal
Global Const aMatrOrdErr=   2   'Orders not valid
Global Const aMatrNotSq=    3   'Matrix not squared
Global Const aMatrSing=     4   'Matrix singolar
Global Const aMatrParamErr= 5   'Invalid Parameter
Global Const aMatrNoVect=   6   'Vector expected not Matrix
Global Const aMatrRanksErr= 7   'Wrong Matrix ranks
Global Const aMatrVectPointsErr=8'Wrong vector of points
Global Const aMatrRankErr=  9   'Rank of matrix of coefficients greather then n-2
Global Const aMatrNoSolut=  10  'System without Solutions
Global Const aMatrRC_Err=   11  'Wrong SWAP Row or Col
Global Const aMatrNoDef=    20  'Matrix not defined
Global Const aMatrIs_Zero=  21  'Matr is Zero
Global Const aElemOrderNoValid=50'Invalid aElemOrder


';shows (Output.l=0) and/or returns (Output.l=1) the DLL info (version, language,...)
Public Declare Function aAbout Lib "aNuMet.dll" ( _
       ByVal Output As Long) As Long
' returns a pointer to the returned string

';Calculates the k coefficients of the polynomial of grade k-1 passing trou the given points
Public Declare Function aCalcCoeffPolin Lib "aNuMet.dll" ( _
       aPoints As Any,  _
       ByVal NoPoints As Long,  _
       ByVal Rank As Long,  _
       vCoeff As Any) As Long

';Calculates Vector {vB} of Coefficients as per {vB} = ([aX]T * [aX])^(-1) * ([aX]T * {vY})
Public Declare Function aCalcVectCoeff Lib "aNuMet.dll" ( _
       arrX As Long,  _
       ByVal n As Long,  _
       ByVal k As Long,  _
       vY As Any,  _
       vB As Any) As Long
''{B} = ([X]T * [X])^(-1) * ([X]T * {Y})
''n*1    k*n    n*k          k*n    n*1
''k-1=rank of the polynomium

';Duplicate Matr [aSrc] in [aDest]
Public Declare Function aCopy Lib "aNuMet.dll" ( _
       aSrc As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aDest As Any) As Long

';copies matrix [aSrc] in [aDest];must have same order
Public Declare Function aCopyArray Lib "aNuMet.dll" ( _
       aSrc As Any,  _
       aDest As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long) As Long

';Calculates the Determinant of [aMatrA];stores result in DetMatrA
Public Declare Function aDet Lib "aNuMet.dll" ( _
       aMatrA As Any,  _
       ByVal rc As Long,  _
       dDetMatrA As Double) As Long

';Calculates the Determinant of [aMatrA]; return a double
Public Declare Function aDetN Lib "aNuMet.dll" ( _
       aMatrA As Any,  _
       ByVal rc As Long) As Double

';Diagonalises a Squared Matrix
Public Declare Function aDiag Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long) As Long

';Calculates the difference of two matrices [aRes]=[aSrc1]-[aSrc2]
Public Declare Function aDiffMem Lib "aNuMet.dll" ( _
       aSrc1 As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aSrc2 As Any,  _
       aRes As Any) As Long

';Calculates the difference of two matrices [aRes]=[aSrc1]-[aSrc2]
Public Declare Function aDiff Lib "aNuMet.dll" ( _
       aSrc1 As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aSrc2 As Any,  _
       aRes As Any) As Long

';Divides two matrices [Res]=[Num]/[Den]
Public Declare Function aDiv Lib "aNuMet.dll" ( _
       arrNum As Long,  _
       ByVal rc As Long,  _
       arrDenom As Long,  _
       aResult As Any) As Long

';Duplicate Matr [aSrc] in [aDest]
Public Declare Function aDupl Lib "aNuMet.dll" ( _
       aSrc As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aDest As Any) As Long

';checks and return Storage Order of Elements in Array;input by array
Public Declare Function aElemOrder Lib "aNuMet.dll" ( _
       aMatr As Any) As Long
'to be used to define how the calling program stores elements of an array (by row or by column)
'aMatr must be Squared of min 4 Doubles with aMatr(0,1)=2, aMatr(1,0)<>2

';gets Storage order internal variable
Public Declare Function aElemOrderGet Lib "aNuMet.dll" () As Long

';returns Storage Order of Elements in Array;input by String
Public Declare Function aElemOrderSt Lib "aNuMet.dll" ( _
       ByVal st As String) As Long
'to be used to define how the calling program stores elements of an array (by row or by column)
'arrA must be Squared of min 4 Doubles with arrA(0,1)=2, arrA(1,0)<>2

';sets Storage order internal variable
Public Declare Function aElemOrderSet Lib "aNuMet.dll" ( _
       ByVal lp As Long) As Long

';Sets/gets Storage order internal variable; Tp values: 0=Detect, 1=DetectStr, 2=Set, 3=Get
Public Declare Function aElemOrderEx Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal tp As Long) As Long

';calculates the x's for a given y of a Polynomial of grade 2 (y=a*x^2+b*x+c)
Public Declare Function aGetXsOfQuadr Lib "aNuMet.dll" ( _
       y As Long,  _
       vCoeff As Any,  _
       ByVal n As Long,  _
       dx1 As Long,  _
       dx2 As Long) As Long

';calculates the solution y for a given x of the Polynomial of grade n - having {vCoeff(n)}
Public Declare Function aGetYPolin Lib "aNuMet.dll" ( _
       dX As Double,  _
       vCoeff As Any,  _
       ByVal n As Long,  _
       dY As Double) As Long

';Inverts Matrix [aDest] (must be Squared)
Public Declare Function aInv Lib "aNuMet.dll" ( _
       aDest As Any,  _
       ByVal rc As Long) As Long

';compares two matrices;return -1 if are equal
Public Declare Function aMatrAreEquals Lib "aNuMet.dll" ( _
       aMatr1 As Any,  _
       ByVal r1 As Long,  _
       ByVal c1 As Long,  _
       aMatr2 As Any,  _
       ByVal r2 As Long,  _
       ByVal c2 As Long) As Long

';returns -1 if Matrices are ORTOGONALs, Must be squared (aInv)
Public Declare Function aMatrAreOrtog Lib "aNuMet.dll" ( _
       aMatr1 As Any,  _
       ByVal rc As Long,  _
       aMatr2 As Any) As Long
'[A] * [B] = [I] => A(m,p) * B(p,n) = I(m,n)

';returns -1 if Matrix is ORTOGONAL, Must be squared (aInv)
Public Declare Function aMatrIsOrtog Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long) As Long

';returns -1 if Matrix is Singolar (Det=0);must be Squared
Public Declare Function aMatrIsSing Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long) As Long

';returns -1 if Matrix is Unit (main diag elem = 1, others = 0). Must be Squared
Public Declare Function aMatrIsUnit Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long) As Long

';returns -1 if Array is Zero (all Elements=0);must be Squared
Public Declare Function aMatrIsZero Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long) As Long

';returns Module of a Matrix of rc rows and 1 column: A(rc,1)
Public Declare Function aMatrMod Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long,  _
       dMod As Double) As Long

';Multiplies two Matrices;result in *aRes;Orders must be: [aSrc1(rr,kk1)] * [aSrc2(kk2,cc)] = [aRes(rr,cc)]
Public Declare Function aMultEx Lib "aNuMet.dll" ( _
       aSrc1 As Any,  _
       ByVal rr As Long,  _
       ByVal kk1 As Long,  _
       aSrc2 As Any,  _
       ByVal kk2 As Long,  _
       ByVal cc As Long,  _
       aRes As Any) As Long
' number of cols of aSrc1 must be equalt ot number of rows of aSrc2
'''{No Col 1 Matr. = No Righe 2 Matr.  As  A(m,p) * B(p,n) = C(m,n)}

';Multiplies two Squared Matrices;result in *aRes
Public Declare Function aMultSq Lib "aNuMet.dll" ( _
       aSrc1 As Any,  _
       ByVal rc As Long,  _
       aSrc2 As Any,  _
       aRes As Any) As Long
'''{No Col 1 Matr. = No Righe 2 Matr.  As  A(m,p) * B(p,n) = C(m,n)}

';multiplies squared matrix [aSrc1(r,c)] by vector {vSrc2(c)};result in vector {vRes(r)}
Public Declare Function aMultVect Lib "aNuMet.dll" ( _
       aSrc1 As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       vSrc2 As Any,  _
       vRes As Any) As Long
'res=aMultVect(@XT(), k, k, @vY(), @XTY()) ;'multiply [XT(k,n)]*{Y(n)}=[XTY(n)]

';multiplies squared matrix [aSrc1(rc,rc)] by vector {vSrc2(rc)};result in vector {vRes(rc)}
Public Declare Function aMultVectSq Lib "aNuMet.dll" ( _
       aSrc1 As Any,  _
       ByVal rc As Long,  _
       vSrc2 As Any,  _
       vRes As Any) As Long

';invert sign of each element of an array (a(r,c)=-a(r,c))
Public Declare Function aOpp Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long) As Long

';Power of Matrix (es. [mA]^3 = [mA]*[mA]*[mA]; Exp must be integer
Public Declare Function aPow Lib "aNuMet.dll" ( _
       aSrc1 As Any,  _
       ByVal rc As Long,  _
       ByVal Exp As Long,  _
       aRes As Any) As Long
'''{No Col 1 Matr. = No Righe 2 Matr.  As  A(m,p) * B(p,n) = C(m,n)}

';Returns Matrix Elements in a String
Public Declare Function aPrint Lib "aNuMet.dll" ( _
       aMtr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       ByVal Perif As String,  _
       ByVal frmt As String,  _
       ByVal Comment As String,  _
       ByVal sep As String) As Long
'returned value is a pointer to the string containing the matrix values

';Returns Matrix Elements in a String (last parameter *s)
Public Declare Function aPrintEx Lib "aNuMet.dll" ( _
       aMtr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       ByVal sPerif As String,  _
       ByVal sFrmt As String,  _
       ByVal sComment As String,  _
       ByVal sSep As String,  _
       ByVal sRetStr As String) As Long
'returns lenght of string returned

';Calculates the Scalar Product of scal*[aMatr]; result in [aMatr]
Public Declare Function aProdScal Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       ByVal scal As Double) As Long

';Calculates the Scalar Sum of scal+[aMatr]; result in [aMatr]
Public Declare Function aSumScal Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       ByVal scal As Double) As Long

';Shows Matrix Elements in a MessageBox (ignore DebugF)
Public Declare Function aShow Lib "aNuMet.dll" ( _
       aMtr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long) As Long
'returned value is a pointer to the string containing the matrix values

';Shows Matrix Elements in a MessageBox (ignore DebugF)
Public Declare Function aShowByLong Lib "aNuMet.dll" ( _
       ByVal Mtr As Long,  _
       ByVal rows As Long,  _
       ByVal cols As Long) As Long
' returned value is a pointer to the string containing the matrix values
' used in lieu of aShow() to have 'Mtr As Long' in the VB Function declaration

'; Solves the System {vX} = [A(rc,rc)]*{vB}; result in *vX pointing to {vX(0)}
Public Declare Function aSist Lib "aNuMet.dll" ( _
       aMatrA As Any,  _
       ByVal rc As Long,  _
       vB As Any,  _
       vX As Any) As Long

';Sums two matrices [aRes]=[aAdd1]+[aAdd2]
Public Declare Function aSum Lib "aNuMet.dll" ( _
       aAdd1 As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aAdd2 As Any,  _
       aRes As Any) As Long

';Sum two Matrices, stores in [aRes] (25% faster than nested For loops)
Public Declare Function aSumMem Lib "aNuMet.dll" ( _
       aAdd1 As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aAdd2 As Any,  _
       aRes As Any) As Long

';Swaps content of two matrices. Must be of the same orders
Public Declare Function aSwap Lib "aNuMet.dll" ( _
       aM1 As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aM2 As Any) As Long

';swaps row/col RC1 with row/col RC2 in matrix [aMAtr(rows, cols)]
Public Declare Function aSwapRC Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       ByVal SwapRows As Long,  _
       ByVal RC1 As Long,  _
       ByVal RC2 As Long) As Long
' parameter SwapRows<>0 swaps Rows, SwapRows=0 swap columns

' ;Calculates Trace of aMatr (must be Squared); result a double pointed by *dTrace
Public Declare Function aTrace Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long,  _
       dTrace As Double) As Long

' ;Calculates Trace of aMatr (must be Squared); return result as double
Public Declare Function aTraceN Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long) As Double

';Traspose Matrix aMatr
Public Declare Function aTrasp Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long) As Long

';Traspose Matrix aMatrA into aMatrD (only Squared)
Public Declare Function aTraspEx Lib "aNuMet.dll" ( _
       aMatrA As Any,  _
       ByVal rows As Long,  _
       ByVal cols As Long,  _
       aMatrD As Any) As Long

';Traspose Matrix aMatr (only Squared)
Public Declare Function aTraspSq Lib "aNuMet.dll" ( _
       aMatr As Any,  _
       ByVal rc As Long) As Long

';returns Module of Array of rc rows and 1 column: A(rc,1)
Public Declare Function aVectMod Lib "aNuMet.dll" ( _
       vA As Any,  _
       ByVal rc As Long,  _
       dMod As Double) As Long

';calculate a CRC of one caracter for Text; returns a string
Public Declare Function sCRC Lib "aNuMet.dll" ( _
       ByVal text As String) As String

'
Public Declare Function GetRegType Lib "aNuMet.dll" () As Long

'
Public Declare Function IntBezier2D Lib "aNuMet.dll" ( _
       ByVal Vec0 As Double,  _
       ByVal Vec1 As Double,  _
       ByVal Vec2 As Double,  _
       ByVal Vec3 As Double,  _
       ByVal a As Double,  _
       ByVal res As Double) As Long

';Interpolates x between two intervals (x2-x1) and (y2-y1);result in res
Public Declare Function InterpLin Lib "aNuMet.dll" ( _
       x As Long,  _
       x1 As Long,  _
       x2 As Long,  _
       y1 As Long,  _
       Y2 As Long,  _
       res As Long) As Long

'; Determine if a given long is prime; return -1 if Prime, otherwise 0
Public Declare Function IsPrime Lib "aNuMet.dll" ( _
       ByVal n As Long) As Long

'; test if number is prime; return -1 if yes, Divisor if No
Public Declare Function lIsPrime Lib "aNuMet.dll" ( _
       ByVal TestPrime As Long) As Long

'; Set Internal DebugFlag; if <> 0 and Show Error Message Boxes
Public Declare Function SetDebugF Lib "aNuMet.dll" ( _
       ByVal DebugFlag As Long) As Long

';get error description
Public Declare Function GetE_ErrDescr Lib "aNuMet.dll" ( _
       ByVal ErrNum As Long) As Long

